#!/usr/bin/perl
###########################################################################
#    Mysql Web based Administration
#    Written by Ying Gao, gaoying@hotmail.com, http://billow.cjb.net
#    It's a free script. You can modify it freely!
###########################################################################

use gymysqlvars qw(%Config);
use gymysql     qw($dbh);
use strict;
use vars       qw($TableName); 

$| = 1;
gymysql::check_refer();

my $message = "";
my %input = gymysql::Get_Form_Data(0);
gymysql::GetSetDatabaseInfo($input{'dbname'});
$TableName         = $input{'table'};

my $EncodeDBName    = gymysql::url_encode($Config{'dbname'});
my $EncodeTableName = gymysql::url_encode($TableName);
my $EncodeSqlcommand = gymysql::url_encode($input{'sqlcommand'});

gymysql::send_header("$Config{'sitename'}");
gymysql::db_connect();
gymysql::table_header(gymysql::ShowIndex(4,"Add Record",$TableName));

my $cursor;
$cursor=$dbh->prepare("describe $TableName") || gymysql::cgi_error("Describe $TableName failed, <em>$DBI::errstr</em>");
$cursor->execute;

my(@fields,@fieldtypes,@fielddefaults,@fielddesc) = ();

while (@fielddesc = $cursor->fetchrow) {
  push @fields, $fielddesc[0];
  push @fieldtypes, $fielddesc[1];
  push @fielddefaults, $fielddesc[4];
}

print qq~
<center>
<h2>Adding a new record to table <font color=BLUE>$TableName</font>.</h2></center>
<form method=post action='add.pl?dbname=$EncodeDBName&table=$EncodeTableName&sqlcommand=$EncodeSqlcommand'>
~;

print "<table align=center border=1 cellpadding=0 cellspacing=0>\n";
print "<tr bgcolor=$Config{'itemheader0'}><td align=center>FieldName</td><td align=center>Type</td><td align=center>Value</td></tr>";
my($field,$fieldname,$fielddesc);
my $coloridx = 0;

while ($#fields > -1) {
  $field = shift @fielddefaults;
  $fieldname = shift @fields;
  $fielddesc = shift @fieldtypes;
  
  #Add some field you do not want to input here!
  #next if($fieldname eq "ID");
 
  print "<tr bgcolor=$Config{'itemcolor'.$coloridx}><td>$fieldname</td>\n";
  print "<td>$fielddesc</td>\n<td>";
  
  print webeditfield($fielddesc, "field_$fieldname", $field);
  print "\n</td></tr>\n";
  $coloridx = ($coloridx) ? 0:1;  
}

print qq~
</table>
<center><input type=submit value='Add Record'> <input type=reset></center>
</form>
~;

gymysql::send_footer();
gymysql::db_disconnect();
gymysql::exit;


sub webeditfield {
  my $result = "";
  my($type, $name, $val) = @_;
  my($x);
  $x = $1 if($type =~ /.\((\d+)/);
  
  
  if (substr($type, 0, 5) eq 'enum(') 
  {
    my $args = substr($type, 5, -1);
    my @list = split(/,/, $args);
    $result .= "<select name=$name>";
    while (my $option = shift @list) {
      if ($option =~ /^'(.*)'$/) {
        $option = $1;
      }
      if ($option eq "$val") {
        $result .= "<option selected>";
      } else {
        $result .= "<option>";
      }
      $result .= "$option\n";
    }
    $result .= "</select>";
  }
  elsif(($type eq "text") || ($x > 60))
  {
  	$result .= "<textarea name='$name' cols=50 rows=4>$val</textarea>";
  }
  elsif($x > 0)
  {
  	$result .= "<input name='$name' value='$val' size='$x' maxlength='$x'>";
  }
  else
  {
  	$result .= "<input name='$name' value='$val' size='30'>";
  }
  return $result;
}
